	include "doorsos.h"
	include "graphlib.h"
	include "userlib.h"
	;include "tios.h"

SetFont	MACRO
	move.w  #\1,-(a7)               ; use font #
	jsr      doorsos::FontSetSys       ; set the font
	addq.l    #2,a7                  ; clean up the stack
                ENDM

WriteStr	MACRO	;x,y,col,str
	move.w	#\3,-(a7)
	pea	\4(pc)
	move.w	#\2,-(a7)
	move.w	#\1,-(a7)
	jsr	doorsos::DrawStrXY
	lea	10(a7),a7
                ENDM

	xdef	_ti89
	;xdef	_ti92plus
	xdef	_comment
	xdef	_main


_comment:
    dc.b "Saucers",0

_main:
g_begin:
    ; Execution will start here, at the _main label
    jsr      graphlib::clr_scr          ; clear the screen
g_begin_no_clear:

 SetFont	    2 ; use font #2 (large font)
 WriteStr 50,0,4,saucers

 SetFont	    1
 WriteStr 25,19,4,by

 SetFont	    0
 WriteStr 57,10,4,version
 WriteStr 0,32,4,about0
 WriteStr 0,42,4,about1
 WriteStr 0,52,4,about2

waitkey:
	jsr	userlib::idle_loop	; waits for a key press
                                   ; is pressed.

    cmp.w    #270,d0                ; Test F3 key
    bne    skipintro
;intro
    jsr      graphlib::clr_scr      ; clear the screen

 SetFont	   1 ; use font #2 (large font)
 WriteStr 0,0,4,infostr0
 WriteStr 0,10,4,infostr1
 WriteStr 0,20,4,infostr2
 WriteStr 0,30,4,infostr3

 SetFont	   0
 WriteStr 0,45,4,infostr4


;bsr putstring

    jsr      userlib::idle_loop        ; library routine which waits until a key
	bra g_begin
                                    ; is pressed.
skipintro:

    cmp.w    #269,d0                ; Test F2 key
    bne      skipinstructions

    jsr      graphlib::clr_scr      ; clear the screen

 SetFont	   1
 WriteStr 0,0,4,inststr0
 WriteStr 0,10,4,inststr1
 WriteStr 0,20,4,inststr2
 WriteStr 0,30,4,inststr3
 WriteStr 0,40,4,inststr3b

 SetFont	   0
 WriteStr 0,54,4,inststr4
 WriteStr 0,62,4,inststr5
 WriteStr 0,70,4,inststr6

    
    jsr      userlib::idle_loop        ; library routine which waits until a key
	bra g_begin

skipinstructions:
    cmp.w    #264,d0                ; Test ESC key
    beq      g_exit
    cmp.w    #268,d0                ; Test F1 key
    bne      g_begin_no_clear

;game

   jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)
;start_game_loop:
;   jsr	userlib::idle_loop	; waits for a key press
;    cmp.w    #268,d0                ; Test F1 key
;    bne      start_game_loop

	move.w	#0,player_x ; initilize positions
	move.w	#0,player_y

	move.w	#40,alien0_x ; initilize positions
	move.w	#40,alien0_y

	move.w	#10,alien1_x ; initilize positions
	move.w	#50,alien1_y


	jsr	graphlib::clr_scr	;clears the main screen (1st bitplane)
	jsr	graphlib::gray4	;switches to 4 grayshades mode
	move.w	#1,graphlib::choosescreen	;set all graphlib functions to grayscale mode

	move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
	jsr	graphlib::clr_scr	;clears the second bitplane


   SetFont 0
   WriteStr 0,10,4,mission0
   move.b #0,d0
   cmp.b  #0,d0
   beq draw_player

;mask for key input
;move.b %11111100,($600018)  ;set the row with 2nd in it
 ;move.w #65000,d2
;  \wait2:

; move.w #65000,d1
;  \wait:
;   move.b $60001b,d0          ;read back keypress data
;   dbra.w d1,\wait
;   dbra.w d2,\wait2
main_game_loop:

; slow down

 move.l pause,d1
; move.l #75000,d1

  \wait:
	nop
   dbra.l d1,\wait
 move.l #0,pause
 move.l #9000,pause ;pause used to compensate for not moving the good player

; key test

  move.b ($60001b),d0          ;read back keypress data
;move.b d0,($600019)  ;set the row with 2nd in it

   btst.b #0,d0                 ;bit 0 is column 0
   bne	  notup                   ;if bit reset, up is pressed
   tst.w  player_y
   ble    notup
   move.l #4000,pause ;no pause
   sub.w  #1,player_y
notup:
   btst.b #2,d0                 ;bit 1 is column 1
   bne	  notdown                   ;if bit reset, down is pressed
   cmp.w  #92,player_y
   bge    notdown
   move.l #4000,pause ;no pause
   add.w  #1,player_y
notdown:
   btst.b #1,d0                 ;bit 2 is column 2
   bne	  notleft                 ;if bit reset, left is pressed
   tst.w  player_x
   ble    notleft
   move.l #4000,pause ;no pause
   sub.w  #2,player_x
notleft:
   btst.b #3,d0                 ;bit 3 is column 3
   bne	  notright                 ;if bit reset, right is pressed
   cmp.w  #128,player_x
   bge    notright
   move.l #4000,pause ;no pause
   add.w  #2,player_x
notright:
   btst.b #6,d0                 ;bit 6 is column 6
   beq	  game_exit                   ;if bit reset, clear is pressed

; move alien only 1/4 of the time
	add.b	#1,alienmove
	cmp.b	#4,alienmove
	bne	skip_alien_move
	clr.b	alienmove

move_the_aliens:
; move aliens
; move alien 0
	move.w  player_y,d0
	cmp.w	alien0_y,d0
	beq	doneya0
	ble	moveup0
	add.w	#2,alien0_y
moveup0:
	sub.w	#1,alien0_y
doneya0:

; move alien 1

; don't let aliens touch
;	move.w  alien0_y,d0
;	add.w	#14,d0
;	cmp.w	alien1_y,d0
;	ble	donecpm1
;
;	move.w  alien1_y,d0
;	add.w	#14,d0
;	cmp.w	alien0_y,d0
;	ble	donecpm1
;
;	move.w  alien0_x,d0
;	add.w	#34,d0
;	cmp.w	alien1_x,d0
;	ble	donecpm1
;
;	move.w  alien1_x,d0
;	add.w	#34,d0
;	cmp.w	alien0_x,d0
;	ble	donecpm1
;	
;	bra	donexa1
;donecpm1:

	move.w  player_x,d0
	cmp.w	alien1_x,d0
	beq	donexa1
	ble	moveleft1
	add.w	#2,alien1_x
moveleft1:
	sub.w	#1,alien1_x
donexa1:


skip_alien_move:

	cmp.b	#2,alienmove
	bge	skip_alien_move_again


	move.w  player_x,d0
	cmp.w	alien0_x,d0
	beq	donexa0
	ble	moveleft0
	add.w	#2,alien0_x
moveleft0:
	sub.w	#1,alien0_x
donexa0:

donecpm1:
	move.w  player_y,d0
	cmp.w	alien1_y,d0
	beq	doneya1
	ble	moveup1
	add.w	#2,alien1_y
moveup1:
	sub.w	#1,alien1_y
doneya1:


skip_alien_move_again:

; colision dectection
; first alien
	move.w  player_y,d0
	add.w	#6,d0
	cmp.w	alien0_y,d0
	ble	donecpm

	move.w  alien0_y,d0
	add.w	#6,d0
	cmp.w	player_y,d0
	ble	donecpm


	move.w  player_x,d0
	add.w	#24,d0
	cmp.w	alien0_x,d0
	ble	donecpm

	move.w  alien0_x,d0
	add.w	#24,d0
	cmp.w	player_x,d0
	ble	donecpm


	
	bra	loser
donecpm:
	move.w  player_y,d0
	add.w	#6,d0
	cmp.w	alien1_y,d0
	ble	donecpm2

	move.w  player_x,d0
	add.w	#24,d0
	cmp.w	alien1_x,d0
	ble	donecpm2

	move.w  alien1_y,d0
	add.w	#6,d0
	cmp.w	player_y,d0
	ble	donecpm2

	move.w  alien1_x,d0
	add.w	#24,d0
	cmp.w	player_x,d0
	ble	donecpm2


	bra	loser
donecpm2:


; draw horz line:
;	move.w	#0,d0
;	move.w	#93,d1
;	move.w	#160,d2
;	move.w	#2,d3
;	jsr	graphlib::horiz
 draw_player:
	move.l	graphlib::plane0,a1	;adress of the 1st bitplane
	move.w  player_x,d0 ;x
	move.w  player_y,d1 ;y
	lea     saucer2(pc),a0          ; move adress of string to the stack
	lea     mask(pc),a2          ; move adress of string to the stack
	jsr	graphlib::put_sprite2
; draw enemy
; alien 1
	move.w  alien1_x,d0 ;x
	move.w  alien1_y,d1 ;y

	lea     saucer1(pc),a0          ; move adress of string to the stack
	lea     mask(pc),a2          ; move adress of string to the stack
	jsr	graphlib::put_sprite2

; alien 0
	move.w  alien0_x,d0 ;x
	move.w  alien0_y,d1 ;y

	;lea     saucer1(pc),a0          ; move adress of string to the stack
	lea     mask(pc),a2          ; move adress of string to the stack
	jsr	graphlib::put_sprite2


; alien 1
	move.w  alien1_x,d0 ;x
	move.w  alien1_y,d1 ;y

	;lea     saucer1(pc),a0          ; move adress of string to the stack
	lea     mask2(pc),a2          ; move adress of string to the stack
	jsr	graphlib::put_sprite2


 ;draw player
	move.l	graphlib::plane1,a1	;adress of the 1st bitplane
	move.w  player_x,d0 ;x
	move.w  player_y,d1 ;y
	lea     saucer0(pc),a0          ; move adress of string to the stack
	lea     mask(pc),a2          ; move adress of string to the stack
	jsr	graphlib::put_sprite2
; draw enemy

; alien 1
	move.w  alien1_x,d0 ;x
	move.w  alien1_y,d1 ;y

	lea     saucer2(pc),a0          ; move adress of string to the stack
	lea     mask(pc),a2          ; move adress of string to the stack
	jsr	graphlib::put_sprite2

; alien 0
	move.w  alien0_x,d0 ;x
	move.w  alien0_y,d1 ;y

	;lea     clearer(pc),a0          ; move adress of string to the stack
	;jsr	graphlib::put_sprite

	;lea     saucer2(pc),a0          ; move adress of string to the stack
	lea     mask(pc),a2          ; move adress of string to the stack
	jsr	graphlib::put_sprite2
; alien 1
	move.w  alien1_x,d0 ;x
	move.w  alien1_y,d1 ;y

	;lea     saucer2(pc),a0          ; move adress of string to the stack
	lea     mask2(pc),a2          ; move adress of string to the stack
	jsr	graphlib::put_sprite2

  move.b ($60001b),d0          ;read back keypress data
   btst.b #7,d0                 ;bit 7 is column 7
   bne	  no_pause                   ;if bit reset, clear is pressed
    clr.w	graphlib::choosescreen	;set all graphlib functions to Black and White mode
    jsr	graphlib::gray2		;restores Black and White mode
    jsr      userlib::idle_loop        ; library routine which waits until a key
    move.w	#1,graphlib::choosescreen	;set all graphlib functions to Black and White mode
    jsr	graphlib::gray4		;restores Black and White mode
    move.l	graphlib::plane0,a1	;adress of the 2nd bitplane
    jsr	graphlib::clr_scr	;clears the second bitplane
    move.l	graphlib::plane1,a1	;adress of the 2nd bitplane
    jsr	graphlib::clr_scr	;clears the second bitplane

no_pause:
 

	bra main_game_loop
loser:

    clr.w	graphlib::choosescreen	;set all graphlib functions to Black and White mode
    jsr	graphlib::gray2		;restores Black and White mode


    move.w   #0,-(a7)               ; use font #0 (small font)
    jsr      doorsos::FontSetSys       ; set the font
    add.l    #2,a7                  ; clean up the stack

    move.w   #4,-(a7)               ; move the first param to the stack
    lea      lost(pc),a0          ; move adress of string to the stack
    move.l   a0,-(a7)
    move.w   #40,-(a7)               ; push position
    move.w   #20,-(a7)               ; push position
    jsr	     doorsos::DrawStr	;calls the ROM function which draws a string in current font
    add.l    #10,a7                 ; restore the stack pointer

    jsr      userlib::idle_loop        ; library routine which waits until a key
    jsr      userlib::idle_loop        ; library routine which waits until a key
    jsr      userlib::idle_loop        ; library routine which waits until a key

	bra	g_begin
	
game_exit:
	clr.w	graphlib::choosescreen	;set all graphlib functions to Black and White mode
	jsr	graphlib::gray2		;restores Black and White mode
	bra	g_begin
g_exit:
	rts ;I am learning (I don't want it to run code in the data section)

pause:
    dc.l 0
 saucer0:	dc.w	8 	;-> height of the sprite
		dc.w	4	;width in bytes
		dc.l	%00000000000000000000000000000000
		dc.l	%00000000000000000000000000000000
		dc.l	%00000000000001111110000000000000
		dc.l	%00000000000011111111000000000000
		dc.l	%00000000000011111111000000000000
		dc.l	%00000000000001111110000000000000
		dc.l	%00000000000000000000000000000000
		dc.l	%00000000000000000000000000000000

 saucer1:	dc.w	10 	;-> height of the sprite
		dc.w	4	;width in bytes
mask2:		dc.l	%00000000000000000000000000000000
		dc.l	%00000000000000000000000000000000
		dc.l	%00000000000001111110000000000000
		dc.l	%00000000111111111111111100000000
		dc.l	%00000111111111111111111111100000
		dc.l	%00001111111111111111111111110000
		dc.l	%00000111111111111111111111100000
		dc.l	%00000000111111111111111100000000
		dc.l	%00000000000000000000000000000000
		dc.l	%00000000000000000000000000000000

 saucer2:	dc.w	10 	;-> height of the sprite
		dc.w	4	;width in bytes
		dc.l	%00000000000000000000000000000000
		dc.l	%00000000000000000000000000000000
		dc.l	%00000000000000000000000000000000
		dc.l	%00000000111100000000111100000000
		dc.l	%00000111111100000000111111100000
		dc.l	%00001111111110000001111111110000
		dc.l	%00000111111111111111111111100000
		dc.l	%00000000111111111111111100000000
		dc.l	%00000000000000000000000000000000
		dc.l	%00000000000000000000000000000000
mask:
		dc.l	%00000000001111111111110000000000
		dc.l	%00001111111111111111111111100000
		dc.l	%00111111111111111111111111111100
		dc.l	%01111111111111111111111111111110
		dc.l	%01111111111111111111111111111110
		dc.l	%01111111111111111111111111111110
		dc.l	%01111111111111111111111111111110
		dc.l	%01111111111111111111111111111110
		dc.l	%00111111111111111111111111111100
		dc.l	%00000111111111111111111111100000

player_x:
    dc.w 0
player_y:
    dc.w 0
alien0_x:
    dc.w 0
alien0_y:
    dc.w 0
alien1_x:
    dc.w 0
alien1_y:
    dc.w 0
saucers:
    dc.b "Saucers",0
version:
    dc.b "Version 0.10",0
by:
    dc.b "By Sean D'Epagnier",0
about0:
    dc.b "F1 - Play",0
about1:
    dc.b "F2 - Instructions",0
about2:
    dc.b "F3 - About",0
infostr0:
    dc.b "Saucers is a game ported",0
infostr1:
    dc.b "from dos to the 89.  You",0
infostr2:
    dc.b "can find the original game",0
infostr3:
    dc.b "at:",0
infostr4:
    dc.b "http://www.firethroat.com",0
inststr0:
    dc.b "Use ",21,22,23,24," to move around",0
inststr1:
    dc.b "'2nd beams items up to you",0
inststr2:
    dc.b "'",27," increases your speed",0
inststr3:
    dc.b "CLEAR exits the game",0
inststr3b:
    dc.b "F1 pauses the game",0
inststr4:
    dc.b "'these actions reduce your power",0
inststr5:
    dc.b "Do not use any other keys (they may do",0
inststr6:
    dc.b "unexpected things)",0
mission0:
    dc.b "Try and go between them, this may be level 1",0
lost:
    dc.b "You LOSE!",0
power:
    dc.b "Power:",0
alienmove:
    dc.b 0
        end
